PROJECT=skeleton
VERSION=0.0.2

DISTFILES=skeleton.exe skeleton.bmp SDL.dll \
          readme.html readmejp.html COPYING NEWS README-SDL.txt \
          markoff.png markon.png retry.png check.png close.png \
          $(PROJECT)-$(VERSION)-src.zip
SRCFILES=Makefile makefile.inc makefile.linux sdl.c \
         skeleton.c skeleton.h \
         file.c file.h \
         random.c random.h \
         mkbmp.c

CFLAGS+=-I"../SDL-1.2.14/include/SDL"
LDFLAGS+=-L"../SDL-1.2.14/lib" -mwindows
LDLIBS+=-lSDL

BMPS=0.bmp 1.bmp 2.bmp 3.bmp 4.bmp 5.bmp 6.bmp 7.bmp 8.bmp 9.bmp \
     black.bmp cursor.bmp markoff.bmp markon.bmp retry.bmp check.bmp close.bmp

default: skeleton.exe mkbmp.exe

skeleton.exe: sdl.o file.o skeleton.o random.o SDL_win32_main.o
sdl.o: sdl.c skeleton.h random.h
file.o: file.c file.h skeleton.h
skeleton.o: skeleton.c skeleton.h random.h
random.o: random.c random.h

mkbmp.exe: mkbmp.o SDL_win32_main.o

skeleton.bmp: $(BMPS)
	mkbmp.exe $@ $^

.PHONY: png

png: markoff.png markon.png retry.png check.png close.png

%.png: %.bmp
	bmp2png -9 $<
	optipng -o 7 $@

$(PROJECT)-$(VERSION)-src.zip: $(SRCFILES)

clean:
	del sdl.o
	del skeleton.o
	del file.o
	del random.o
	del skeleton.exe
	del mkbmp.o
	del mkbmp.exe
