#include <SDL.h>
#include <stdio.h>

int main(int argc, char *argv[])
{
	SDL_Surface *bmp = NULL, *screen = NULL;
	SDL_Rect rc;
	int i, n, w, h, depth;
	char name[10];
	if (argc < 1) {
		return 0;
	}
	if(SDL_Init(SDL_INIT_VIDEO) == -1) {
		fprintf(stderr, "Could not initialize SDL: %s.\n", SDL_GetError());
		return -1;
	}
	if (argc > 2) {
		bmp = SDL_LoadBMP(argv[2]);
		if (! bmp) goto END;
		w = bmp->w * (argc - 2);
		h = bmp->h;
		screen = SDL_SetVideoMode(w, h, bmp->format->BitsPerPixel, SDL_SWSURFACE);
		if (! screen) goto END;
		rc.x = 0; rc.y = 0;
		rc.w = bmp->w; rc.h = bmp->h;
		SDL_BlitSurface(bmp, &rc, screen, &rc);
		SDL_FreeSurface(bmp);
		for (i = 3; i < argc; i ++) {
			rc.x += rc.w;
			bmp = SDL_LoadBMP(argv[i]);
			if (! bmp) goto END;
			SDL_BlitSurface(bmp, NULL, screen, &rc);
			SDL_FreeSurface(bmp);
		}
		SDL_SaveBMP(screen, argv[1]);
	}
	else {
		bmp = SDL_LoadBMP(argv[1]);
		if (! bmp) goto END;
		n = bmp->w / bmp->h;
		w = h = bmp->h;
		depth = bmp->format->BitsPerPixel;
		fprintf(stderr, "split to %d files. width: %d, height: %d, depth: %d\n", n, w, h, depth);
		screen = SDL_SetVideoMode(w, h, depth, SDL_SWSURFACE);
		if (! screen) goto END;
		rc.x = rc.y = 0;
		rc.w = rc.h = bmp->h;
		for (i = 0; i < n; i ++) {
			SDL_BlitSurface(bmp, &rc, screen, NULL);
			sprintf(name, "%d.bmp", i);
			SDL_SaveBMP(screen, name);
			rc.x += rc.w;
		}
	}
	END:
	SDL_FreeSurface(bmp);
	SDL_Quit();
	return 0;
}
