#pragma once

#define ROWS 12
#define COLS 12

#define MAXLENGTH 5

#define MAXLINES (ROWS * COLS / 2)

typedef short cell_type;
typedef cell_type board_type[ROWS][COLS];
typedef unsigned short index_type[ROWS][COLS];

enum direction {
	NO_DIRECTION = 0, UP = 1, RIGHT = 1 << 1, DOWN = 1 << 2, LEFT = 1 << 3,
};

enum value {
	BLACK = -1, WHITE = 0, FILLED = 1,
};

struct line {
	short x, y, dx, dy, length;
};

struct number {
	short length;
	cell_type digit[MAXLENGTH];
};


void clear_board(board_type);
void reset_board(board_type);
int find_cell(board_type, int *, int *, cell_type);
void print_board(board_type);
void print_board2(board_type);

int is_vertical_begin(board_type, int, int);
int is_horizontal_begin(board_type, int, int);
int check_box(board_type, int, int, cell_type);
int check_line_length(board_type, int, int);
int count_line_length(board_type, int, int, int, int);
int check_black_box(board_type);
int check_split(board_type);
int check_link_count(board_type);
int check_dig(board_type, int, int);
int dig(board_type, int, int);
int select_dig(board_type);
void init_board(board_type);

void print_lines(struct line *, int);
int count_lines(board_type);
int set_lines(board_type, struct line *, int);
void print_nums(struct number *, int);
int num_cmp(const void *, const void *);
void set_number_index(struct line *, short *, int);

int line_cmp(const void *, const void *);
int fill_number(board_type, struct line *, struct number *, int, int,
	int (*)(void *), void *);
void set_line_index(struct line *, int, index_type);

int check_duplicate_num(struct number *, int);
int check_solution(board_type, struct line *, struct number *, short *,
	unsigned short *, int);
int check_duplicate_solution(board_type, struct line *, struct number *,
	short *, unsigned short *, int, int (*)(void *), void *);
int check_solve(int step, board_type, struct line *, struct number *, short *,
	int, int (*)(void *), void *);

int get_vertical_line(index_type, int, int);
int get_horizontal_line(index_type, int, int);
int can_set_number(board_type, struct line *, struct number *);
int set_number(board_type, struct line *, struct number *);
